package pl.polgrabiat.websockets.chat.websocketschat.handlers;

import org.springframework.web.socket.WebSocketSession;
import pl.polgrabiat.websockets.chat.websocketschat.dto.ChannelCtx;
import pl.polgrabiat.websockets.chat.websocketschat.dto.GlobalCtx;
import pl.polgrabiat.websockets.chat.websocketschat.dto.UserCtx;

import java.io.IOException;
import java.util.StringTokenizer;

public class PrivMessageHandler implements SessionCommandHandler {
    @Override
    public boolean handleCommand(GlobalCtx globalCtx, WebSocketSession session, String payload, String command, String data) throws IOException {
        StringTokenizer tokenizer = new StringTokenizer(data);
        String destination = tokenizer.nextToken();
        if (destination.startsWith("#")) {
            // channel

            ChannelCtx channel = globalCtx.getChannels().get(destination);
            if (channel == null) {
                sendMessage(session,
                        globalCtx, destination,"MSG invalid destination");
                return true;
            }

            UserCtx userCtx = globalCtx.getUserSessions().get(session);

            if (!channel.getUsers().contains(userCtx)) {
                sendMessage(session, globalCtx, destination, "MSG You are not the member of this channel");
                return true;
            }

            // sending to other users

            for (UserCtx user : channel.getUsers()) {
                sendMessage(user.getSession(), globalCtx, destination, payload);
            }

            return true;

        } else {
            // user


            UserCtx userCtx = globalCtx.getUserSessions().get(globalCtx.getUserNameSessions().get(destination));
            UserCtx sourceUserCtx = globalCtx.getUserSessions().get(session);
            if (userCtx == null) {
                sendMessage(session,
                        globalCtx, destination,"MSG invalid destination");
                return true;
            }

            sendMessage(userCtx.getSession(),
                    globalCtx, sourceUserCtx.getNick(), payload); // destination and source
            sendMessage(session,
                    globalCtx, sourceUserCtx.getNick(), payload); // destination and source

            return true;
        }
    }
}
